from gurobipy import *

def setupMaster(size, amount, width, master, masterVars, masterCons):
    """ --- Setup Master Problem with artificial vars --- """
    master.params.outputFlag = 0
    for i in range(len(size)):
        newvar = master.addVar(0, GRB.INFINITY, 1.0, GRB.CONTINUOUS, 'Pat_'+str(i+1))
        masterVars += [newvar]
    master.update()
    for i in range(len(amount)):
        newconst = master.addConstr( int(width/size[i]) * masterVars[i], GRB.GREATER_EQUAL, amount[i], 'Dem_'+str(i+1))
        masterCons += [newconst]
    master.update()

def setupPricing(size, amount, width, pricer, pricerVars):
    """ --- Setup Pricing --- """
    pricer.params.outputFlag = 0
    pricer.modelSense = GRB.MAXIMIZE
    pricerVarsIndex = range(len(size))
    for i in pricerVarsIndex:
        newvar = pricer.addVar(0, GRB.INFINITY, 1.0, GRB.INTEGER, 'Use_'+str(i+1))
        pricerVars += [newvar]
    pricer.update()
    pricer.addConstr(LinExpr(size, pricerVars), GRB.LESS_EQUAL, width, 'RollWidth')
    pricer.update()

